/* editmail.h
**
** released into the PUBLIC DOMAIN 30 jul 1990 by jim nutt
** Changes released into the PUBLIC DOMAIN 10 jul 1994 by John Dennis
**
*/

#define NOSPELL
#define func

/* prototypes */

static void func backspace(void);
static void func rotate(void);
static void func delete_character(void);
static void func delword(void);
static void func go_left(void);
static void func go_right(void);
static void func go_word_right(void);
static void func go_word_left(void);
static void func newline(void);
static void func go_up(void);
static void func go_down(void);
static void func go_pgup(void);
static void func go_pgdown(void);
static void func delete_line(void);
static void func go_eol(void);
static void func cut(void);
static void func toggle_quote(void);
static void func paste(void);
static void func anchor(void);
static void func quit(void);
static void func die(void);
static void func imptxt(void);
static void func outtext(void);
static void func shellos(void);
static void func go_bol(void);
static void func toggle_ins(void);
static void func tabit(void);
static void func go_tos(void);
static void func go_bos(void);
static void func go_bom(void);
static void func go_tom(void);
static void func nada(void);
static void func killeol(void);
static void func undelete(void);
static void func bytecount(void);
static void func do_help(void);
static void func doscmd(void);
static void func unblock(void);
static void func editheader(void);
static void func setup(void);


/* table of normal keystrokes (<ctrl> + normal keypresses) */

void (func *editckeys[256])(void) =
{
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /*  0 */
backspace,tabit,  NULL,    NULL,    NULL,    newline, NULL,    NULL, /*  8 */
NULL,    NULL,    NULL,    NULL,    delword,undelete, NULL,    NULL, /* 10 */
NULL,    delete_line,NULL, die,     NULL,    NULL,    NULL,    NULL, /* 18 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 20 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 28 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 30 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 38 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 40 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 48 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 50 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 58 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 60 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 68 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 70 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    backspace,/*78*/
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 80 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 88 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 90 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 98 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* A0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* A8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* B0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* B8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* C0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* C8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* D0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* D8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* E0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* E8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* F0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL  /* F8 */
};

/* table of extended keystrokes (<alt> keypresses) */

void (func *editakeys[256])(void) =
{
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /*  0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /*  8 */
toggle_quote,outtext,editheader,rotate,setup,NULL, unblock,  imptxt, /* 10 */
shellos,paste,    NULL,    NULL,    NULL,    NULL,    anchor,  quit, /* 18 */
delete_line,NULL, NULL,  do_help,   NULL,    killeol, NULL,    NULL, /* 20 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    cut,     NULL, /* 28 */
bytecount,NULL,   NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 30 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 38 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  go_bol, /* 40 */
go_up,go_pgup,    NULL, go_left,    NULL,go_right,    NULL,  go_eol, /* 48 */
go_down,go_pgdown,toggle_ins,delete_character,NULL,NULL, NULL, NULL, /* 50 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 58 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 60 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 68 */
NULL,    NULL,    NULL,go_word_left,go_word_right,go_bom,go_bos,go_tom,/* 70 */
doscmd,  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 78 */
NULL,    NULL,    NULL,    NULL,    go_tos,  NULL,    NULL,    NULL, /* 80 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 88 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 90 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* 98 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* A0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* A8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* B0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* B8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* C0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* C8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* D0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* D8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* E0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* E8 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL, /* F0 */
NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL  /* F8 */
};

/* table linking the functions with their config names */

const struct _command editcmds[] = {
    {"backspace",backspace},        {"deleol",   killeol},
    {"left",     go_left},          {"right",    go_right},
    {"wordright",go_word_right},    {"wordleft", go_word_left},
    {"newline",  newline},          {"up",       go_up},
    {"down",     go_down},          {"pgup",     go_pgup},
    {"pgdn",     go_pgdown},        {"delline",  delete_line},
    {"goeol",    go_eol},           {"cut",      cut},
    {"anchor",   anchor},           {"paste",    paste},
    {"quit",     quit},             {"abort",    die},
    {"import",   imptxt},           {"export",   outtext},
    {"shell",    shellos},          {"gobol",    go_bol},
    {"insert",   toggle_ins},       {"undel",    undelete},
    {"tab",      tabit},            {"null",     nada},
    {"top",      go_tos},           {"bottom",   go_bos},
    {"first",    go_tom},           {"last",     go_bom},
    {"del",      delete_character}, {"killword", delword},
    {"toggleq",  toggle_quote},     {"bytecount",bytecount},
    {"oscmd",    doscmd},           {"unblock",  unblock},
    {"edithdr",  editheader},       {"setup",    setup},
    {NULL,NULL}
};

/* end */
